<script lang="ts">
  import { onMount, beforeUpdate, afterUpdate } from "svelte";
  import type {
    ProductModel,
    ProductOptionModel,
  } from "src/models/product.type";
  import {
    formViewMode,
    pageSelectedStore,
    productGroupListStore,
    productSelectedStore,
    productTypeListStore,
  } from "src/store";
  import { Page } from "src/page";
  import AlertMessage from "src/widgets/AlertMessage";
  import UploadImageList from "src/widgets/UploadImageList.svelte";
  import type { ProductGroupModel } from "src/models/product.group.type";
  import { getProductGroupAPI } from "src/apis/get-product-group";
  import ProductInputOption from "./ProductInputOption.svelte";
  import { createProductAPI } from "src/apis/create-product";
  import { updateProductAPI } from "src/apis/update-product";
  import { getProductsAPI } from "src/apis/get-products";
  import { getProductTypeAPI } from "src/apis/get-product.type";

  const patternModelClear: ProductModel = {
    uuid: "",
    productId: "", // รหัสสินค้า
    productName: "", // ชื่อสินค้า
    productDesc: "", // รายละเอียดสินค้า
    productOptions: [],
    image: [], // รูปภาพสินค้ามีได้หลายรูป
    discount: 0, // ราคาส่วนลดสินค้า คิดเป็นเปอร์เซ็นต์
    price: 0, // ราคาสินค้า
    selected: false, // ถูกเลือกหรือไม่ถูกเลือก
    productType: [], // ประเภทสินค้า
    group: [], // หมวดหมู่ ขายดี ลดราคา ได้รับความนิยม
    amount: 0, // จำนวนชิ้นที่เลือก
    postDate: "", // วันที่ลงสินค้า
  };
  let showBorderRed = false;
  let formInsert = false;

  $: validateForm = !!(
    $productSelectedStore &&
    $productSelectedStore.productId &&
    $productSelectedStore.productName &&
    $productSelectedStore.discount >= 0 &&
    $productSelectedStore.productDesc &&
    $productSelectedStore.price &&
    $productSelectedStore?.image?.length &&
    $productSelectedStore?.group?.length &&
    $productSelectedStore?.productType?.length && 
    $productSelectedStore?.productOptions?.length
  );

  $productSelectedStore.group = $productSelectedStore?.group?.length
    ? $productSelectedStore.group
    : [];

  $productSelectedStore.productType = $productSelectedStore?.productType?.length
    ? $productSelectedStore.productType
    : [];

  productSelectedStore.subscribe((resp) => {
    formInsert = false;
  });

  onMount(async () => {
    // ข้อมูลกลุ่ม/หมวดหมู่
    await getProductGroupAPI();
    // ข้อมูลประเภทสินค้า
    await getProductTypeAPI();
    $productSelectedStore.discount = 0;
  });

  async function submitForm() {
    Object.values($productSelectedStore).forEach((valInput) => {
      if (valInput == "") {
        showBorderRed = true;
      }
      if (typeof valInput == "object" && Object.values(valInput).length <= 0) {
        showBorderRed = true;
      }
    });
    if (validateForm) {
      try {
        if ($productSelectedStore.uuid) {
          await updateProductAPI($productSelectedStore);
        } else {
          await createProductAPI($productSelectedStore);
        }
        formInsert = true;
        AlertMessage.alert("ทำรายการเรียบร้อยแล้ว");
        $pageSelectedStore = Page["PRODUCT_LIST"];
      } catch (err) {
        formInsert = false;
        AlertMessage.alert(
          `<p class="text-red-500">ทำรายการ ผิดพลาด</p> <br> ${JSON.stringify(
            err
          )}`
        );
      }
    }
  }

  function onClearForm() {
    $productSelectedStore = patternModelClear;
    showBorderRed = false;
  }
</script>

<div
  class="overflow-auto h-screen pb-24 pt-2 pr-2 pl-2 md:pt-0 md:pr-0 md:pl-0"
>
  <div class="flex flex-col flex-wrap sm:flex-row ">
    <div class="w-full">
      <div class="m-4">
        <div class="shadow-lg rounded p-4 bg-white bg-gray-700 w-full">
          <div class="w-full flex justify-end">
            <p
              class="px-3 py-1 text-gray-900 rounded-xl {$productSelectedStore.uuid &&
              !$formViewMode
                ? 'bg-yellow-400'
                : $formViewMode
                ? 'bg-blue-300'
                : 'bg-green-300'}"
            >
              MODE: {$productSelectedStore.uuid && !$formViewMode
                ? "แก้ไข"
                : $formViewMode
                ? "อ่านอย่างเดียว"
                : "เพิ่มข้อมูล"}
            </p>
          </div>
          <div class="flex justify-between w-full">
            {#if $productSelectedStore.uuid}
              <div class="flex w-full py-5 justify-start">
                <p
                  on:click={() => ($pageSelectedStore = Page["PRODUCT_LIST"])}
                  class="text-white text-lg bg-red-600 px-5 py-.5 rounded-lg
                            hover:bg-red-700 cursor-pointer"
                >
                  ย้อนกลับ
                </p>
              </div>
            {/if}
            {#if !$formViewMode}
              <div class="flex w-full py-5 justify-end">
                <p
                  on:click={onClearForm}
                  class="text-white text-lg bg-red-600 px-5 py-.5 rounded-lg
                            hover:bg-red-700 cursor-pointer"
                >
                  เคลียร์ฟอร์ม
                </p>
              </div>
            {/if}
          </div>

          <div class="flex justify-end py-2 text-green-500">
            <p>
              {formInsert
                ? `ID: ${$productSelectedStore.productId} ทำรายการเรียบร้อยแล้ว`
                : ""}
            </p>
          </div>
          <div class="w-full h-34 mb-4 justify-center my-2">
            <p class="w-full text-center text-white">รูปภาพสินค้า</p>
            <UploadImageList
              disable={$formViewMode}
              bind:imageFileList={$productSelectedStore.image}
            />
          </div>
          <div class="flex w-full pt-16">
            <div class="mb-4 w-1/2">
              <p class="w-full text-right text-white">รหัสสินค้า</p>
              <input
                disabled={$formViewMode}
                bind:value={$productSelectedStore.productId}
                class="{showBorderRed && !$productSelectedStore.productId
                  ? 'border-red-500'
                  : ''} appearance-none block w-full py-3 px-4 leading-tight
                            text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
                            focus:border-white rounded focus:outline-none"
                type="text"
                placeholder="รหัสสินค้า"
              />
            </div>
            <div class="mb-4 pl-10 w-1/2">
              <p class="w-full text-right text-white">ชื่อสินค้า</p>
              <input
                disabled={$formViewMode}
                bind:value={$productSelectedStore.productName}
                class="{showBorderRed && !$productSelectedStore.productName
                  ? 'border-red-500'
                  : ''} appearance-none block w-full py-3 px-4 leading-tight
                            text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
                            focus:border-white rounded focus:outline-none"
                type="text"
                placeholder="ชื่อสินค้า"
              />
            </div>
          </div>
          <div class="flex w-full">
            <div class="mb-4 w-1/2">
              <p class="w-full text-right text-white">รายละเอียดสินค้า</p>
              <textarea
                rows="5"
                disabled={$formViewMode}
                bind:value={$productSelectedStore.productDesc}
                class="{showBorderRed && !$productSelectedStore.productDesc
                  ? 'border-red-500'
                  : ''} appearance-none block w-full py-3 px-4 leading-tight
                            text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
                            focus:border-white rounded focus:outline-none"
                type="text"
                placeholder="รายละเอียดสินค้า"
              />
            </div>
            <div class="mb-4 pl-10 w-1/2">
              <p class="w-full text-right text-white">กลุ่ม/หมวดหมู่</p>
              <div
                class="block bg-gray-200 rounded p-2 {showBorderRed &&
                $productSelectedStore?.group?.length == 0
                  ? 'border border-red-500'
                  : ''}"
              >
                <span class="text-gray-700">* เลือกได้มากกว่า 1 ตัวเลือก</span>
                <div class="mt-2">
                  {#if $productGroupListStore?.length > 0}
                    {#each $productGroupListStore as option}
                      <div>
                        <label class="inline-flex items-center">
                          <input
                            disabled={$formViewMode}
                            bind:group={$productSelectedStore.group}
                            type="checkbox"
                            value={option.typeName}
                            class="form-checkbox text-red-500"
                          />
                          <img
                            alt="..."
                            src={option.icon}
                            class="w-6 h-6 mx-2 my-2"
                          />
                          <span class="mx-1">{option.typeName}</span>
                        </label>
                      </div>
                    {/each}
                  {/if}
                </div>
              </div>
            </div>
          </div>

          <div class="flex w-full">
            <div class="mb-4 w-1/2">
              <p class="w-full text-right text-white">ประเภทสินค้า</p>
              <div
                class="block bg-gray-200 rounded p-2 {showBorderRed &&
                $productSelectedStore?.productType?.length == 0
                  ? 'border border-red-500'
                  : ''}"
              >
                <span class="text-gray-700">* เลือกได้มากกว่า 1 ตัวเลือก</span>
                <div class="mt-2">
                  {#if $productTypeListStore?.length > 0}
                    {#each $productTypeListStore as option}
                      <div>
                        <label class="inline-flex items-center">
                          <input
                            disabled={$formViewMode}
                            bind:group={$productSelectedStore.productType}
                            type="checkbox"
                            value={option.typeName}
                            class="form-checkbox text-red-500"
                          />
                          <span class="mx-1">&nbsp;&nbsp;{option.typeName}</span>
                        </label>
                      </div>
                    {/each}
                  {/if}
                </div>
              </div>
              <p class="w-full text-right text-white">ราคาสินค้า</p>
              <input
                disabled={$formViewMode}
                bind:value={$productSelectedStore.price}
                class="{showBorderRed && !$productSelectedStore.price
                  ? 'border-red-500'
                  : ''} appearance-none block w-full py-3 px-4 leading-tight
                            text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
                            focus:border-white rounded focus:outline-none"
                type="number"
                placeholder="ราคาสินค้า"
              />
              <p class="w-full text-right text-white">
                ส่วนลดสินค้าเป็นเปอร์เซน
              </p>
              <input
                disabled={$formViewMode}
                bind:value={$productSelectedStore.discount}
                class="{showBorderRed &&
                !$productSelectedStore.discount &&
                $productSelectedStore.discount != 0
                  ? 'border-red-500'
                  : ''} appearance-none block w-full py-3 px-4 leading-tight
                            text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
                            focus:border-white rounded focus:outline-none"
                type="number"
                placeholder="ส่วนลดสินค้าเป็นเปอร์เซน"
              />
            </div>
            <div class="mb-4 pl-10 w-1/2">
              <p class="w-full text-right text-white">ตัวเลือกในการซื้อ</p>
              <ProductInputOption
                disable={$formViewMode}
                bind:productOptionList={$productSelectedStore.productOptions}
                customCss={showBorderRed &&
                $productSelectedStore?.productOptions?.length == 0
                  ? "border border-red-500"
                  : ""}
              />
            </div>
          </div>

          {#if !$formViewMode}
            <div class="text-center">
              {#if !validateForm && showBorderRed}
                <p class="text-red-800 p-3">
                  *** กรุณากรอกฟอร์มให้เรียบร้อยก่อน
                </p>
              {/if}
              <button
                on:click={submitForm}
                class="pt-5 mb-5 inline-block w-full py-4 px-8 leading-none text-white rounded
                          shadow {!validateForm
                  ? 'hover:bg-blue-200 bg-blue-200'
                  : 'hover:bg-blue-900 bg-blue-800'}"
              >
                {$productSelectedStore.uuid && !$formViewMode
                  ? "บันทึกการแก้ไข"
                  : "บันทึกข้อมูล"}
              </button>
            </div>
          {/if}
        </div>
      </div>
    </div>
  </div>
</div>
